uab = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "Metrognome-2.0")

uab.hasIcon = "Interface\\CURSOR\\\Cast"
uab.defaultPosition = "RIGHT"
uab.hideWithoutStandby = true
uab.independentProfile = true
uab.hasNoColor = true
uab.cannotDetachTooltip = true

uab.constants = {}

uab.constants.buttonWidth = 38
uab.constants.buttonHeight = 38
uab.constants.groupInfo = {
	{ name = "player", unitcount = 1, displayName = "Player" },
	{ name = "pet", unitcount = 1, displayName = "Pet" },
--	{ name = "party", unitcount = 4, displayName = "Party" },
--	{ name = "partypet", unitcount = 4, displayName = "Party Pet" },
--	{ name = "raid", unitcount = 50, displayName = "Raid" }, -- 40 for raid, 10 for main tanks
	{ name = "partyraid", unitcount = 60, displayName = "Party/Raid" },
	{ name = "target", unitcount = 1, displayName = "Target" },
	{ name = "targettarget", unitcount = 1, displayName = "Target of Target" },
	{ name = "targettargettarget", unitcount = 1, displayName = "ToT Target" },
	{ name = "focus", unitcount = 1, displayName = "Focus" },
	{ name = "focustarget", unitcount = 1, displayName = "Focus Target" },
}

uab.constants.grow = {}
uab.constants.grow.up = "u"
uab.constants.grow.down = "d"
uab.constants.grow.left = "l"
uab.constants.grow.right = "r"

uab.constants.placement = {}
uab.constants.placement.left = "l"
uab.constants.placement.topleft = "tl"
uab.constants.placement.top = "t"
uab.constants.placement.topright = "tr"
uab.constants.placement.right = "r"
uab.constants.placement.bottomright = "br"
uab.constants.placement.bottom = "b"
uab.constants.placement.bottomleft = "bl"

uab.constants.anchor = {}
uab.constants.anchor.top = "top"
uab.constants.anchor.left = "left"

uab.layoutManagers = {}
uab.unitEffectClasses = {}
uab.unitEffectClassInstances = {}

uab.classes = {}
uab.interfaces = {}
uab.mixins = {}

function uab.print(msg)
    if msg then DEFAULT_CHAT_FRAME:AddMessage(msg) end
end

function uab.pdebug(msg)
    if uab.debug and msg then
        if uab.savedebug then
            table.insert(UABDebug, msg)
        else
            DEFAULT_CHAT_FRAME:AddMessage(msg)
        end
    end
end

UABDebug = {}

uab.mixins.aceDB = AceLibrary("AceDB-2.0")
uab.mixins.aceEvent = AceLibrary("AceEvent-2.0")
uab.mixins.aceOO = AceLibrary("AceOO-2.0")
uab.mixins.aura = AceLibrary("SpecialEvents-Aura-2.0")
uab.mixins.banzai = AceLibrary("Banzai-1.1")
uab.mixins.tablet = AceLibrary("Tablet-2.0")

uab.interfaces.IUnitEffect = uab.mixins.aceOO.Interface {
	GetName = "function",
	GetDisplayName = "function",
	GetDefaultHighlightColor = "function",
    IsActive = "function",
}

uab.interfaces.IActionData = uab.mixins.aceOO.Interface {
    IsUsable = "function",
	GetAttributes = "function",
	GetClassName = "function",
	GetIcon = "function",
	GetText = "function",
    GetCount = "function",
    GetCooldown = "function",
	SetTooltip = "function",
}

uab.interfaces.IActionSetLayout = uab.mixins.aceOO.Interface {
	ArrangeButtons = "function",
	GetConfig = "function",
	SetSettings = "function",
}

uab.interfaces.IActionSetLayoutConfig = uab.mixins.aceOO.Interface {
	GetFrame = "function", -- GetFrame()
	SettingsChanged = "function", -- SettingsChanged(settings) or SettingsChanged()
	UseDefaults = "function", -- UseDefaults()
	MenuOptionArgs = "function", -- MenuOptionArgs()
}

uab.interfaces.IActionSetLayoutManager = uab.mixins.aceOO.Interface {
	GetLayout = "function",
	GetName = "function",
	GetDisplayName = "function",
}
		 		 
--[[
Main add-on functionality
--]]

uab.profileDefaults = {
    tooltips = true,
    directcast = true,
    activators = {
    },
    scale = {
        player = {
			usedefault = true,
			value = 1.0,
		},
        pet = {
			usedefault = true,
			value = 1.0,
		},
        partyraid = {
			usedefault = true,
			value = 1.0,
		},
        focus = {
			usedefault = true,
			value = 1.0,
		},
        focustarget = {
			usedefault = true,
			value = 1.0,
		},
        target = {
			usedefault = true,
			value = 1.0,
		},
        targettarget = {
			usedefault = true,
			value = 1.0,
		},
        targettargettarget = {
			usedefault = true,
			value = 1.0,
		},
        default = {
			value = 1.0,
		},
    },
    position = {
        player = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        pet = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        partyraid = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        focus = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        focustarget = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        target = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        targettarget = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        targettargettarget = {
			usedefault = true,
			value = { x = 0.0, y = 0.0, }
		},
        default = {
			value = { x = 0.0, y = 0.0, }
		},
    },
    layout = "uab.Bar",
}

uab.options = {
    type = 'group',
    args = {
        actionsets = {
            type = 'group',
            name = "Action Sets",
            desc = "Create, modify, and remove action sets",
    		order = 10,
            args = {},
        },
        
        lookandfeel = {
            type = 'group',
            name = "Look and Feel",
            desc = "Options that affect how buttons appear.  Includes layout, positioning, scaling, and button behavior",
    		order = 30,
            args = {
                layout = {
                    type = 'group',
                    name = "Layout",
                    desc = "Select and configure button layout options",
            		order = 40,
                    args = {
                        configure = {
                            type = 'group',
                            name = "Configure",
                            desc = "Configure current layout options",
                            args = {}
                        },
                        select = {
        	                type = 'text',
        	                name = "Select",
        	                usage = "<name>",
        	                desc = "Select the current layout to use",
        	                get = function()
        					    local managers = uab:GetManagers()
        					    local mgr = managers[uab.db.profile.layout].manager
        					    
        					    return mgr:GetDisplayName()
        					end,
        	                set = function(name)
        					    local managers = uab:GetManagers()
        
        						for _, mgr in pairs(managers) do
        						    if mgr.manager:GetDisplayName() == name then
        								uab.db.profile.layout = mgr.manager:GetName()
        								uab.main:LayoutChanged()
        								break
        							end
        						end
        	                end,
                        },
                    },
                },
                position = {
                    type = 'group',
                    name = "Position",
                    desc = "Action button set positioning offset (x, y)",
            		order = 50,
                    args = {
                        default = {
                            type = 'group',
                            name = "Default",
                            desc = "Default action set button positioning offset (x, y)",
                            disabled = function() return uab.db.profile.position.default.usedefault end,
                    		order = 1,
                            args = {
                                x = {
                                    type = 'range',
                                    name = "X",
                                    desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor)",
                                    min = -100,
                                    max = 100,
                                    step = 1,
                                    isPercent = false,
                                    get = function()
                                        return uab.db.profile.position.default.value.x
                                    end,
                                    set = function(value)
                                        uab.db.profile.position.default.value.x = value
                                        uab.main:PositionChanged()
                                    end,
                                },
                                y = {
                                    type = 'range',
                                    name = "Y",
                                    desc = "Vertical offset (positive is up, negative is down, 0 is over cursor)",
                                    min = -100,
                                    max = 100,
                                    step = 1,
                                    isPercent = false,
                                    get = function()
                                        return uab.db.profile.position.default.value.y
                                    end,
                                    set = function(value)
                                        uab.db.profile.position.default.value.y = value
                                        uab.main:PositionChanged()
                                    end,
                                },
                            },
                        },
                        
                        usedefault = {
                            type = 'group',
                            name = "Use default",
                            desc = "Use the default positioning for the selected groups",
                    		order = 2,
                            args  = {},
                        },
                        
                        spacing1 = {
                    		name = " ",
                    		type = 'header',
                    		order = 3,
                    	},
                        spacing2 = {
                    		name = "Groups",
                    		type = 'header',
                    		order = 4,
                    	},
                    },
                },
                
                scale = {
                    type = 'group',
                    name = "Scale",
                    desc = "Action button scale",
            		order = 60,
                    args = {
                        default = {
                            type = 'range',
                            name = "Default",
                            desc = "Action button scale when 'Use default' is selected",
                            min = 0.05,
                            max = 2.00,
                            step = 0.05,
                            isPercent = true,
                            order = 1,
                            get = function()
                                return uab.db.profile.scale.default.value
                            end,
                            set = function(value)
                                uab.db.profile.scale.default.value = value
                                uab.main:ScaleChanged()
                            end,
                        },
                        usedefault = {
                            type = 'group',
                            name = "Use default",
                            desc = "Use the default scale for the selected groups",
                            order = 2,
                            args  = {
                            },
                        },
                        spacing1 = {
                    		name = " ",
                    		type = 'header',
                    		order = 3,
                    	},
                        spacing2 = {
                    		name = "Groups",
                    		type = 'header',
                    		order = 4,
                    	},
                    },
                },
                directcast = {
                    type = 'toggle',
                    name = "Direct cast",
                    desc = "Use direct click-casting when group contains a single action",
                    order = 61,
                    get = function()
                        return uab.db.profile.directcast
                    end,
                    set = function(v)
                        uab.db.profile.directcast = v
                        uab.main:DirectCastChanged()
                    end,
                },
                tooltip = {
                    type = 'toggle',
                    name = "Tooltips",
                    desc = "Show action tooltips",
            		order = 62,
                    get = function()
                        return uab.db.profile.tooltips
                    end,
                    set = function(v)
                        uab.db.profile.tooltips = v
                    end,
                },
                stayopen = {
                    type = 'toggle',
                    name = "Stay open",
                    desc = "Keep actions displayed after use.  Clicking cancel closes actions",
            		order = 63,
                    get = function()
                        return uab.db.profile.stayopen
                    end,
                    set = function(v)
                        uab.db.profile.stayopen = v
                        uab.main:StayOpenChanged()
                    end,
                },
                fastchangeunit = {
                    type = 'toggle',
                    name = "Fast change unit",
                    desc = "When selected, clicking on a different unit frame in the same group when action buttons are shown will immediately reposition the buttons to the new unit frame and associate any action with that unit.  When not selected, clicking a new unit frame in the same group closes the action buttons",
            		order = 64,
                    get = function()
                        return uab.db.profile.fastchangeunit
                    end,
                    set = function(v)
                        uab.db.profile.fastchangeunit = v
                        uab.main:FastChangeUnitChanged()
                    end,
                },
            }
    	},
    
        spacing3 = {
    		name = " ",
    		type = 'header',
    		order = 70,
    	},
    
        spacing4 = {
    		name = "Unit Effects",
    		type = 'header',
    		order = 80,
    	},
    
        priority = {
            type = 'group',
            name = "Priority",
            desc = "Unit effect priority",
    		order = 90,
            args = {},
        },
        color = {
            type = 'group',
            name = "Highlight color",
            desc = "Effect highlight color",
    		order = 100,
            args = {},
        },
--[[    
        spacing = {
    		name = " ",
    		type = 'header',
    		order = 110,
    	},
    
        reset = {
            type = 'execute',
            name = "Reset",
            desc = "Reset the buttons (debugging only)",
    		order = 120,
            func = function()
                uab:ResetButtons()
            end,
        },
--]]
    },
}

function uab.DropDownSelect(frame, functionData)
    frame[functionData.func](frame, this, functionData.arg1, functionData.arg2, functionData.arg3)
end

function uab.GroupIterate(fcn, self, context)
    local key, val
    for key, val in pairs(uab.constants.groupInfo) do
        if fcn and fcn(self, context, key, val) then
            break
        end
    end
end

function uab:OnInitialize()
    self:RegisterDB("UABDB")
    self:RegisterDefaults('profile', self.profileDefaults)

    local profileoptions = self.mixins.aceDB:GetAceOptionsDataTable(self)

    self:SetupScaleOptions()
    self:SetupOffsetOptions()
    
--[[
    for name, val in pairs(profileoptions) do
        self.options.args[name] = val
    end
--]]

	local layouts = {}

    local managers = uab:GetManagers()

	for _, mgr in pairs(managers) do
	    table.insert(layouts, mgr.manager:GetDisplayName())
	end

	self.options.args.lookandfeel.args.layout.args.select.validate = layouts

    self:SetupUnitEffectOptions()

	self.main = uab.classes.main:new()
	
    self:RegisterChatCommand({ "/unitactionbars", "/uab" }, self.options)
	self.OnMenuRequest = self.options
    
    self:CreateClickActivators()
end

function uab:SetupScaleOptions()
    uab.GroupIterate(
        function(self, context, name, info)
            context.count = context.count + 1
            uab.options.args.lookandfeel.args.scale.args.usedefault.args[info.name] = {
                type = 'toggle',
                name = info.displayName,
                desc = info.displayName.." should use default scale value",
                order = context.count,
                get = function()
                    return uab.db.profile.scale[info.name].usedefault
                end,
                set = function(v)
                    if uab.db.profile.scale[info.name].usedefault and not v then
                        uab.db.profile.scale[info.name].value = uab.db.profile.scale.default.value
                    elseif not uab.db.profile.scale[info.name].usedefault and v then
                        uab.db.profile.scale[info.name].value = nil
                    end
                
                    uab.db.profile.scale[info.name].usedefault = v
                    uab.main:ScaleChanged(info.name)
                end,
            }
        end,
        nil,
        { count = 10 })
    
    uab.GroupIterate(
        function(self, context, name, info)
            context.count = context.count + 1
            uab.options.args.lookandfeel.args.scale.args[info.name] = {
                type = 'range',
                name = info.displayName,
                desc = info.displayName.. " action button scale",
                disabled = function() return uab.db.profile.scale[info.name].usedefault end,
                order = context.count,
                min = 0.05,
                max = 2.00,
                step = 0.05,
                isPercent = true,
                get = function()
                    return uab.db.profile.scale[info.name].value
                end,
                set = function(value)
                    uab.db.profile.scale[info.name].value = value
                    uab.main:ScaleChanged(info.name)
                end,
            }
        end,
        nil,
        { count = 10 })
end

function uab:SetupOffsetOptions()
    uab.GroupIterate(
        function(self, context, name, info)
            context.count = context.count + 1
            uab.options.args.lookandfeel.args.position.args.usedefault.args[info.name] = {
                type = 'toggle',
                name = info.displayName,
                desc = info.displayName.." should use default action button positioning",
                order = context.count,
                get = function()
                    return uab.db.profile.position[info.name].usedefault
                end,
                set = function(v)
                    if uab.db.profile.position[info.name].usedefault and not v then
                        uab.db.profile.position[info.name].value = {}
                        uab.db.profile.position[info.name].value.x = uab.db.profile.position.default.value.x
                        uab.db.profile.position[info.name].value.y = uab.db.profile.position.default.value.y
                    elseif not uab.db.profile.position[info.name].usedefault and v then
                        uab.db.profile.position[info.name].value = nil
                    end
                
                    uab.db.profile.position[info.name].usedefault = v
                    uab.main:PositionChanged(info.name)
                end,
            }
        end,
        nil,
        { count = 10 })
    
    uab.GroupIterate(
        function(self, context, name, info)
            context.count = context.count + 1
            uab.options.args.lookandfeel.args.position.args[info.name] = {
                type = 'group',
                name = info.displayName,
                desc = info.displayName.. " action set button positioning offset (x, y)",
                disabled = function() return uab.db.profile.position[info.name].usedefault end,
                order = context.count,
                args = {
                    x = {
                        type = 'range',
                        name = "X",
                        desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor)",
                        min = -100,
                        max = 100,
                        step = 1,
                        isPercent = false,
                        get = function()
                            return uab.db.profile.position[info.name].value.x
                        end,
                        set = function(value)
                            uab.db.profile.position[info.name].value.x = value
                            uab.main:PositionChanged(info.name)
                        end,
                    },
                    y = {
                        type = 'range',
                        name = "Y",
                        desc = "Vertical offset (positive is up, negative is down, 0 is over cursor)",
                        min = -100,
                        max = 100,
                        step = 1,
                        isPercent = false,
                        get = function()
                            return uab.db.profile.position[info.name].value.y
                        end,
                        set = function(value)
                            uab.db.profile.position[info.name].value.y = value
                            uab.main:PositionChanged(info.name)
                        end,
                    },
                },
            }
        end,
        nil,
        { count = 10 })
end

function uab:SetupUnitEffectOptions()
	local unitEffects = self:GetAllUnitEffects()

    if not self.db.profile.priority then
        self.db.profile.priority = {}
    end

    if not self.db.profile.highlight then
		self.db.profile.highlight = {}
    end

	for name, instance in pairs(unitEffects) do
		if name ~= "default" then
			if not self.db.profile.priority[name] then
				self.db.profile.priority[name] = 50
			end
			
			self.options.args.priority.args[name] = {
	            type = 'range',
	            name = instance:GetDisplayName(),
	            desc = instance:GetDisplayName() .. " priority",
	            min = 1,
	            max = 100,
	            step = 1,
	            isPercent = false,
	            get = function()
	                return uab.db.profile.priority[name]
	            end,
	            set = function(value)
	                uab.db.profile.priority[name] = value
	            end,
	        }
		end
		        
		if not self.db.profile.highlight[name] then
			self.db.profile.highlight[name] = instance:GetDefaultHighlightColor()
		end

		self.options.args.color.args[name] = {
            type = 'color',
            name = instance:GetDisplayName(),
            desc = "Set the border hightlight color when "..instance:GetDisplayName().." is in effect",
            get = function()
                local c = uab.db.profile.highlight[name]
                return c.r, c.g, c.b, c.a
            end,
            set = function(r, g, b, a)
                local c = uab.db.profile.highlight[name]
                c.r, c.g, c.b, c.a = r, g, b, a
            end,
            hasAlpha = true,
        }
	end
end

function uab:CreateClickActivators()
	if not self.db.profile.activators then
	    self.db.profile.activators = {}
	end

	for key, val in pairs(self.db.profile.activators) do
	    self.main:CreateActivator(key, val)
	end
    
    self:RefreshActivatorList()
end

function uab:RefreshActivatorList()
	local order = 10

	local names = {}
	for key, val in pairs(self.db.profile.activators) do
	    table.insert(names, key)
	end

	table.sort(names)

	self.options.args.actionsets.args = {}

    self.options.args.actionsets.args.setup = {
        type = 'execute',
        name = "Setup",
        desc = "Setup the actions for any of the action sets",
        func = function()
            UAB_MainFrame:Show()
        end,
		order = 1,
    }
	
    self.options.args.actionsets.args.spacing1 = {
		name = " ",
		type = 'header',
		order = 3,
	}

    self.options.args.actionsets.args.new = {
        type = 'text',
        name = "New",
        desc = "Create a new action set",
        disabled = function() return not uab.main:FindNextAvailableActivation() end,
        usage = "<name>",
        order = 101,
        get = function() return end,
        set = function(name) uab.main:NewActivator(name) end,
        validate = function(name) return not uab.main:ActivatorExists(name) end,
    }

    self.options.args.actionsets.args.remove = {
        type = 'text',
        name = "Remove",
        desc = "Remove an existing action set",
        disabled = function() return not uab.main:AnyActivators() end,
        usage = "<name>",
        order = 102,
        get = function() end,
        set = function(name) uab.main:RemoveActivator(name) end,
        validate = function(name)
			if uab.db.profile.activators[name] then
				return true
			end
        end,
    }

    if # names > 0 then    
        self.options.args.actionsets.args.spacing2 = {
    		name = " ",
    		type = 'header',
    		order = 200,
    	}
    
        order = 200
        for idx = 1, # names, 1 do
            self.options.args.actionsets.args[names[idx]] = self:CreateActionSetOption(names[idx])
            self.options.args.actionsets.args[names[idx]].order = order
            order = order + 1
        end
    end
end

function uab:CreateActionSetOption(name, order)
    local options
    
    options = {
        type = 'group',
        name = name,
        desc = "Mouse activation settings for actions in the "..name.." action set",
        args = {
            button = {
                type = 'text',
                name = "Button",
                desc = "Select the button to use to activate this action set",
                order = 1,
                get = function()
                    local btn = uab.db.profile.activators[name].button

                    if btn == "LeftButton" then
                        return "left"
                    end

                    if btn == "RightButton" then
                        return "right"
                    end

                    if btn == "MiddleButton" then
                        return "middle"
                    end

                    if btn == "Button4" then
                        return "button4"
                    end

                    return "button5"
                end,
                set = function(button)
                    local btn
                    if button == "left" then
                        btn = "LeftButton"
                    elseif button == "right" then
                        btn = "RightButton"
                    elseif button == "middle" then
                        btn = "MiddleButton"
                    elseif button == "button4" then
                        btn = "Button4"
                    elseif button == "button5" then
                        btn = "Button5"
                    end

                    if btn then
                        uab.main:SetActivatorButton(name, btn)
                    end
                end,

                validate = {"left", "right", "middle", "button4", "button5" }
            },
            keys = {
                type = 'group',
                name = "Keys",
                desc = "Keys that must be pressed for mouse activation",
                order = 2,
                args  = {
                    alt = {
                        type = 'toggle',
                        name = "Alt",
                        desc = "Alt key must be pressed",
						order = 1,
                        get = function()
                            return uab.db.profile.activators[name].prefixalt
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "alt")
                            else
                                uab.main:RemoveActivatorKey(name, "alt")
                            end
                        end,
                    },
                    ctrl = {
                        type = 'toggle',
                        name = "Ctrl",
                        desc = "Ctrl key must be pressed",
						order = 2,
                        get = function()
                            return uab.db.profile.activators[name].prefixctrl
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "ctrl")
                            else
                                uab.main:RemoveActivatorKey(name, "ctrl")
                            end
                        end,
                    },
                    shift = {
                        type = 'toggle',
                        name = "Shift",
                        desc = "Shift key must be pressed",
						order = 3,
                        get = function()
                            return uab.db.profile.activators[name].prefixshift
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "shift")
                            else
                                uab.main:RemoveActivatorKey(name, "shift")
                            end
                        end,
                    },
				    spacing1 = {
						type = 'header',
						name = " ",
						order = 4,
					},
                    clear = {
                        type = 'execute',
                        name = "Clear",
                        desc = "Clear all prefix keys",
						order = 5,
                        func = function()
                            uab.main:ClearActivatorKeys(name)
                        end,
                    },
                },
            },
        
            spacing1 = {
        		name = " ",
        		type = 'header',
        		order = 10,
        	},
	
            active = {
                type = 'toggle',
                name = "Active",
                desc = "Activate this action set",
                get = function()
                    return uab.main:GetActivator(name):Enabled()
                end,
                set = function(v)
                    if v and not uab.main:GetActivator(name):Enabled() then
                        uab.main:EnableActivator(name)
                    elseif not v and uab.main:GetActivator(name):Enabled() then
                        uab.main:DisableActivator(name)
                    end
                end,
        		order = 20,
            }
        },
    }
    
    return options
end

function uab:OnEnable(first)
	self.main:Enable()
end

function uab:OnDisable()
	self.main:Disable()
end

function uab:OnProfileEnable()
    --[[
    Profile changed.  We need to reset all the click activators
    based on the new profile.  This could mean renaming some of
    the click activators, disabling others, and changing the set of
    actions for all groups inside each activator.
    --]]
    --self:OnDisable()
    --self:OnEnable()
end

function uab:OnTooltipUpdate()
	local cat = uab.mixins.tablet:AddCategory("columns", 1)
	cat:AddLine("header", "Unit Action Bars")

	uab.mixins.tablet:SetHint("|cffeda55fClick|r to configure.")
end

function uab:OnClick()
	UAB_MainFrame:Show()
end

function uab:ResetButtons()
    self.main:ResetButtons()
end

function uab:RegisterLayoutManager(managerClass)
	self.layoutManagers[managerClass] = {}
end

function uab:GetManagers()
	local managers = {}

	for managerClass, info in pairs(self.layoutManagers) do
	    if not info.manager then
	        info.manager = managerClass:new()
		end

		managers[info.manager:GetName()] = info
	end

	return managers
end

function uab:RegisterUnitEffect(effectClass)
	self.unitEffectClasses[effectClass] = {}
end

function uab:GetUnitEffect(effectName)
	if not self.unitEffectClassInstances[effectName] then
		for class, info in pairs(self.unitEffectClasses) do
			if not info.instance then
				info.instance = class:new()
				self.unitEffectClassInstances[info:GetName()] = info.instance
			end
			if info.instance:GetName() == effectName then
				break
			end
		end
	end

	return self.unitEffectClassInstances[effectName]
end

function uab:GetAllUnitEffects()
	for class, info in pairs(self.unitEffectClasses) do
		if not info.instance then
			info.instance = class:new()
			self.unitEffectClassInstances[info.instance:GetName()] = info.instance
		end
	end

	return self.unitEffectClassInstances
end

function uab.CloneTable(tbl)
	if type(tbl) == "table" then
        local newtbl = {}

        for val, data in pairs(tbl) do
            newtbl[val] = uab.CloneTable(data)
        end
        
        return newtbl
    elseif type(tbl) == "string" then
        return tbl
    elseif type(tbl) == "number" then
        return tbl
    elseif type(tbl) == "boolean" then
        return tbl
    end
end

function uab.DoStartMoving(frame, btn)
	if (btn == "LeftButton") then
		frame:SetUserPlaced(true)
		frame:StartMoving()
		frame.ismoving = true
	end
end
    			
function uab.DoStopMoving(frame)
	if (frame.ismoving) then
		frame:StopMovingOrSizing()
		frame:SetUserPlaced(true)
		frame.ismoving = nil
	end
end

